package com.netease.urs.oauth1.demo;

import java.io.UnsupportedEncodingException;
import java.net.URLEncoder;
import java.security.GeneralSecurityException;

import javax.crypto.Mac;
import javax.crypto.SecretKey;
import javax.crypto.spec.SecretKeySpec;

import sun.misc.BASE64Encoder;

public class CreateOAuthURLDemo {

	private static final String ENCODE = "utf-8";

	private static final String OUTPUT_SEPARATOR = "--------------------------------";

	private static final String OAUTH_CONSUMER_KEY = "oauth_consumer_key";
	private static final String OAUTH_SIGNATURE_METHOD = "oauth_signature_method";
	private static final String OAUTH_TIMESTAMP = "oauth_timestamp";
	private static final String OAUTH_NONCE = "oauth_nonce";
	private static final String OAUTH_CALLBACK = "oauth_callback";
	private static final String OAUTH_SIGNATURE = "oauth_signature";
	private static final String OAUTH_COOKIE_LOGIN = "oauth_cookie_login";
	private static final String OAUTH_VERSION = "oauth_version";
	private static final String OAUTH_TOKEN = "oauth_token";

	private static final String BASE_URL_REQUEST_TOKEN = "http://reg.163.com/services/oauth1/request_token";
	private static final String BASE_URL_AUTHORIZE = "http://reg.163.com/oauth1/UserAuth.jsp";
	private static final String BASE_URL_ACCESS_TOKEN = "http://reg.163.com/services/oauth1/access_token";
	private static final String BASE_URL_GET_USER_INFO = "http://reg.163.com/services/oauth1/get_user_info";

	/**
	 * ʵʵӦ
	 */
	private String httpMethod = "GET";
	private String oauthConsumerKey = "5060036551";
	private String oauthConsumerSecret = "c87c63ad0618e61f4ffd574fb0d4aac0";
	private String oauthCallBack = "http://reg.163.com";

	/**
	 * ǩֻʹHMAC-SHA1
	 */
	private String oauthSignatureMethod = "HMAC-SHA1";

	/**
	 * 汾ſѡбΪ1.0
	 */
	private String oauthVersion = "1.0";

	/**
	 * ֵΪ0ʱûÿζRequest
	 * TokenȨҪû룻ûֵΪ1ʱûڵ½˻״̬£ûͿԶRequest TokenȨ
	 */
	private String oauthCookieLogin = "1";

	public static void main(String[] args) throws Exception {
		CreateOAuthURLDemo demo = new CreateOAuthURLDemo();
		demo.createRequestTokenUrl();
		// requestTokenΪȡδȨRequest
		// TokenrequestSecretΪӦSecretҪʵʵõtokensecretֵ
		String requestToken = "a2e7f85f372f652b9a7b58039cfe67d1", requestSecret = "316e6e04bc3e6018d3c37bea81b956da";
		demo.createAuthnoirzedUrl(requestToken);
		demo.createAccessTokenUrl(requestToken, requestSecret);
		// accessTokenʹȨRequest TokenȡAccess
		// Token;accessSecretΪӦSecretҪʵʵõtokensecretֵ
		String accessToken = "1511b14f7fa949d16754f83fde2482f2", accessSecret = "bec854858258ffbd77c33cf967678cdf";
		demo.createGetUserInfoUrl(accessToken, accessSecret);
	}

	/**
	 * ɲ1 ȡδȨRequest TokenURL
	 * 
	 * @return
	 * @throws Exception
	 */
	public String createRequestTokenUrl() throws Exception {
		String consumerKey = OAUTH_CONSUMER_KEY + "=" + this.oauthConsumerKey;
		String signMethod = OAUTH_SIGNATURE_METHOD + "=" + this.oauthSignatureMethod;
		String times = OAUTH_TIMESTAMP + "=" + (System.currentTimeMillis() / 1000);
		// ʹɷʽ
		String nonce = OAUTH_NONCE + "=" + System.nanoTime();
		String callback = OAUTH_CALLBACK + "=" + URLEncoder.encode(this.oauthCallBack, ENCODE);
		String version = OAUTH_VERSION + "=" + this.oauthVersion;
		String cookieLogin = OAUTH_COOKIE_LOGIN + "=" + this.oauthCookieLogin;

		String baseString = httpMethod
				+ "&"
				+ URLEncoder.encode(BASE_URL_REQUEST_TOKEN, ENCODE)
				+ "&"
				+ URLEncoder.encode(callback, ENCODE)

				+ URLEncoder.encode("&" + consumerKey + "&" + cookieLogin + "&" + nonce + "&" + signMethod + "&"
						+ times + "&" + version, ENCODE);

		String secret = oauthConsumerSecret + "&";
		String signature = getSignature(baseString, secret);

		StringBuffer sb = new StringBuffer();
		sb.append(BASE_URL_REQUEST_TOKEN).append("?").append(consumerKey).append("&").append(signMethod).append("&")
				.append(times).append("&").append(nonce).append("&").append(version).append("&").append(callback)
				.append("&").append(cookieLogin).append("&").append(OAUTH_SIGNATURE + "=").append(
						URLEncoder.encode(signature, ENCODE));

		System.out.println(OUTPUT_SEPARATOR);
		System.out.println("Request token:");
		System.out.println("baseString:\t" + baseString);
		System.out.println("signature:\t" + signature);
		System.out.println("url:\t\t" + sb.toString());
		System.out.println();

		return sb.toString();
	}

	/**
	 * ɲ2 ûRequest TokenȨURL
	 * 
	 * @param token
	 * @return
	 * @throws Exception
	 */
	public String createAuthnoirzedUrl(String token) throws Exception {
		String baseUrl = BASE_URL_AUTHORIZE;
		String oauth_token = OAUTH_TOKEN + "=" + token;
		String resultUrl = baseUrl + "?" + oauth_token;

		System.out.println(OUTPUT_SEPARATOR);
		System.out.println("Authorize:");
		System.out.println("url:\t" + resultUrl);
		System.out.println();

		return resultUrl;
	}

	/**
	 * ɲ3 ʹȨRequest TokenȡAccess TokenURL
	 * 
	 * @param oauth_token
	 * @param token_secret
	 * @return
	 * @throws Exception
	 */
	public String createAccessTokenUrl(String oauth_token, String token_secret) throws Exception {
		String token = OAUTH_TOKEN + "=" + oauth_token;
		String consumerKey = OAUTH_CONSUMER_KEY + "=" + this.oauthConsumerKey;
		String signMethod = OAUTH_SIGNATURE_METHOD + "=" + this.oauthSignatureMethod;
		String times = OAUTH_TIMESTAMP + "=" + +(System.currentTimeMillis() / 1000);
		// ʹɷʽ
		String nonce = OAUTH_NONCE + "=" + System.nanoTime();
		String version = OAUTH_VERSION + "=" + this.oauthVersion;

		String baseString = httpMethod
				+ "&"
				+ URLEncoder.encode(BASE_URL_ACCESS_TOKEN, ENCODE)
				+ "&"
				+ URLEncoder.encode(consumerKey + "&" + nonce + "&" + signMethod + "&" + times + "&" + token + "&"
						+ version, ENCODE);

		String secret = oauthConsumerSecret + "&" + token_secret;
		String signature = getSignature(baseString, secret);

		StringBuffer sb = new StringBuffer();
		sb.append(BASE_URL_ACCESS_TOKEN).append("?").append(consumerKey).append("&").append(signMethod).append("&")
				.append(times).append("&").append(nonce).append("&").append(version).append("&").append(token).append(
						"&").append(OAUTH_SIGNATURE + "=").append(URLEncoder.encode(signature, ENCODE));

		System.out.println(OUTPUT_SEPARATOR);
		System.out.println("Access token:");
		System.out.println("baseString:\t" + baseString);
		System.out.println("signature:\t" + signature);
		System.out.println("url:\t\t" + sb.toString());
		System.out.println();

		return sb.toString();
	}

	/**
	 * ɲ4 ʹAccess TokenȡûIdURL
	 * 
	 * @param oauth_token
	 * @param token_secret
	 * @return
	 * @throws Exception
	 */
	public String createGetUserInfoUrl(String oauth_token, String token_secret) throws Exception {
		String token = OAUTH_TOKEN + "=" + oauth_token;
		String consumerKey = OAUTH_CONSUMER_KEY + "=" + this.oauthConsumerKey;
		String signMethod = OAUTH_SIGNATURE_METHOD + "=" + this.oauthSignatureMethod;
		String times = OAUTH_TIMESTAMP + "=" + +(System.currentTimeMillis() / 1000);
		// ʹɷʽ
		String nonce = OAUTH_NONCE + "=" + System.nanoTime();
		String version = OAUTH_VERSION + "=" + this.oauthVersion;

		String baseString = httpMethod
				+ "&"
				+ URLEncoder.encode(BASE_URL_GET_USER_INFO, ENCODE)
				+ "&"
				+ URLEncoder.encode(consumerKey + "&" + nonce + "&" + signMethod + "&" + times + "&" + token + "&"
						+ version, ENCODE);

		String secret = oauthConsumerSecret + "&" + token_secret;
		String signature = getSignature(baseString, secret);
		StringBuffer sb = new StringBuffer();
		sb.append(BASE_URL_GET_USER_INFO).append("?").append(consumerKey).append("&").append(signMethod).append("&")
				.append(times).append("&").append(nonce).append("&").append(version).append("&").append(token).append(
						"&").append(OAUTH_SIGNATURE + "=").append(URLEncoder.encode(signature, ENCODE));

		System.out.println(OUTPUT_SEPARATOR);
		System.out.println("Get user info:");
		System.out.println("baseString:\t" + baseString);
		System.out.println("signature:\t" + signature);
		System.out.println("url:\t\t" + sb.toString());

		return sb.toString();
	}

	private byte[] computeSignature(String baseString, String keyString) throws GeneralSecurityException,
			UnsupportedEncodingException {
		SecretKey key = null;
		byte[] keyBytes = keyString.getBytes(ENCODE);
		key = new SecretKeySpec(keyBytes, "HmacSHA1");
		Mac mac = Mac.getInstance("HmacSHA1");
		mac.init(key);
		byte[] text = baseString.getBytes(ENCODE);
		return mac.doFinal(text);
	}

	private String getSignature(String baseString, String key) throws UnsupportedEncodingException,
			GeneralSecurityException {
		BASE64Encoder base64encoder = new BASE64Encoder();
		String signature = base64encoder.encodeBuffer(computeSignature(baseString, key));
		return signature;
	}

}
